/***************************************************************************
                          SDLSpriteList.cpp  -  1.1
                             -------------------
    begin                : Tue Aug 15 2000
    copyright            : (C) 2000 by regis Quercioli
    email                : edorul@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* 
 * 
 *  I have rewrite the Double Chained List
 *  charles vidal 2001
 * 
 */
//////////////////////////////////////////////////////////////////////////////////
#include "SDLSpriteList.h"

//////////////////////////////////////////////////////////////////////////////////
// Default constructor.
//////////////////////////////////////////////////////////////////////////////////
SDLSpriteList::SDLSpriteList(void)

{

	head=NULL;
	tail=NULL;
	m_nSprites = 0;
}

//////////////////////////////////////////////////////////////////////////////////
// Default contructor.
//////////////////////////////////////////////////////////////////////////////////
SDLSpriteList::~SDLSpriteList(void)
{
}

//////////////////////////////////////////////////////////////////////////////////
// Adds a sprite to the sprite list. Only a pointer to a SDLTile object
// is required, however you can also set up the sprite as required.
//////////////////////////////////////////////////////////////////////////////////
SDLSprite *SDLSpriteList::AddSprite(SDLSprite* pTile, int Type, int PosX, int PosY,
					int VelX, int VelY, int State, int Frame, int Delay, Uint32 DelayStart)
{
	SDLSprite* Node;

	// Create a new sprite
	Node = new SDLSprite(pTile);
	if(Node == NULL) 
		return Node;

	// Setup sprite
	Node->SetType(Type);
	Node->SetPos((float)PosX,(float) PosY);
	Node->SetVel(VelX, VelY);
	Node->SetState(State);
	Node->SetFrame(Frame);
	Node->SetDelay(Delay);
	Node->m_DelayStart = DelayStart;
	
 
  	if ( head == NULL )
    	{
		tail = Node;
		head = Node;
		Node -> m_Next = NULL;
		Node -> m_Prev = NULL;
    	}
  else
    	{
		tail -> m_Next = Node;
		Node -> m_Prev = tail;
		Node -> m_Next = NULL;
		tail = Node;
    	}

	m_nSprites++;

	return Node;
}

//////////////////////////////////////////////////////////////////////////////////
// Adds a sprite to the sprite list. A pointer to an already existing SDLSprite
// is required.
//////////////////////////////////////////////////////////////////////////////////
SDLSprite* SDLSpriteList::AddSprite(SDLSprite* pNode)
{
  	if ( head == NULL )
    	{
		tail = pNode;
		head = pNode;
		pNode -> m_Next = NULL;
		pNode -> m_Prev = NULL;
    	}
  else
    	{
		tail -> m_Next = pNode;
		pNode -> m_Prev = tail;
		pNode -> m_Next = NULL;
		tail = pNode;
    	}

	m_nSprites++;

	return pNode;
}

//////////////////////////////////////////////////////////////////////////////////
// Removes a sprite from the list.
//////////////////////////////////////////////////////////////////////////////////
void SDLSpriteList::DelSprite(SDLSprite* pNode)
{

	if (pNode==NULL) {
			fprintf(stderr,"DelSprite NULL \n");
			}
	if (pNode==tail) {
		tail=pNode->m_Prev;
		}

	if (pNode->m_Prev!=NULL) {
				pNode->m_Prev->m_Next=pNode->m_Next;
				}

	if (pNode->m_Next!=NULL) {
				pNode->m_Next->m_Prev=pNode->m_Prev;
				}
	if (pNode==head) {
		head=pNode->m_Next;
		}

	m_nSprites--;

	delete pNode;
}

//////////////////////////////////////////////////////////////////////////////////
// Draws all the sprites in the list to the surface pointed to by lpDDS.
//////////////////////////////////////////////////////////////////////////////////
void SDLSpriteList::Draw(SDL_Surface* lpSDLS, long int ScrnWorldX, long int ScrnWorldY)
{
	SDLSprite* Node;

	// Loop the list and draw the objects
	for(Node = head; Node != NULL; Node = Node->m_Next)
	{
		Node->Draw(lpSDLS, ScrnWorldX, ScrnWorldY);
	}
}
